<html>
<head>
<title>OgreVector2.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreVector2.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreVector2_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Vector2_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Vector2_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreMath_8h.html">OgreMath.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00051"></a><a class="code" href="classOgre_1_1Vector2.html">00051</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053     <span class="keyword">public</span>:
<a name="l00054"></a><a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">00054</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> x, <a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00055"></a>00055 
<a name="l00056"></a>00056     <span class="keyword">public</span>:
<a name="l00057"></a><a class="code" href="classOgre_1_1Vector2.html#a54198b2714496715f6f9ec24c1194cad">00057</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>()
<a name="l00058"></a>00058         {
<a name="l00059"></a>00059         }
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classOgre_1_1Vector2.html#a157950d8cbe0e44a2271479a4f8bcdab">00061</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fX, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fY )
<a name="l00062"></a>00062             : x( fX ), y( fY )
<a name="l00063"></a>00063         {
<a name="l00064"></a>00064         }
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classOgre_1_1Vector2.html#a1c2a513e68d4e223135a5d891a569501">00066</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scaler )
<a name="l00067"></a>00067             : x( scaler), y( scaler )
<a name="l00068"></a>00068         {
<a name="l00069"></a>00069         }
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="classOgre_1_1Vector2.html#a6f05ab5b82a5dd3f191e388d4a734614">00071</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> afCoordinate[2] )
<a name="l00072"></a>00072             : x( afCoordinate[0] ),
<a name="l00073"></a>00073               y( afCoordinate[1] )
<a name="l00074"></a>00074         {
<a name="l00075"></a>00075         }
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="classOgre_1_1Vector2.html#ac04fe07fceec444e2a13b0195bcb2c64">00077</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>( <span class="keyword">const</span> <span class="keywordtype">int</span> afCoordinate[2] )
<a name="l00078"></a>00078         {
<a name="l00079"></a>00079             x = (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[0];
<a name="l00080"></a>00080             y = (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)afCoordinate[1];
<a name="l00081"></a>00081         }
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classOgre_1_1Vector2.html#adf501af1ce3df540dee7953ddb32cb51">00083</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>( <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* <span class="keyword">const</span> r )
<a name="l00084"></a>00084             : x( r[0] ), y( r[1] )
<a name="l00085"></a>00085         {
<a name="l00086"></a>00086         }
<a name="l00087"></a>00087 
<a name="l00090"></a><a class="code" href="classOgre_1_1Vector2.html#aa27656ac177e9a1959749704c5ea6cb2">00090</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">swap</a>(<a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; other)
<a name="l00091"></a>00091         {
<a name="l00092"></a>00092             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(x, other.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>);
<a name="l00093"></a>00093             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(y, other.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00094"></a>00094         }
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classOgre_1_1Vector2.html#a71b01bfe42118ef067e14e1092e7773f">00096</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )<span class="keyword"> const</span>
<a name="l00097"></a>00097 <span class="keyword">        </span>{
<a name="l00098"></a>00098             assert( i &lt; 2 );
<a name="l00099"></a>00099 
<a name="l00100"></a>00100             <span class="keywordflow">return</span> *(&amp;x+i);
<a name="l00101"></a>00101         }
<a name="l00102"></a>00102 
<a name="l00103"></a><a class="code" href="classOgre_1_1Vector2.html#aae029eb05f9ab47565e5b47bb2ee9d91">00103</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )
<a name="l00104"></a>00104         {
<a name="l00105"></a>00105             assert( i &lt; 2 );
<a name="l00106"></a>00106 
<a name="l00107"></a>00107             <span class="keywordflow">return</span> *(&amp;x+i);
<a name="l00108"></a>00108         }
<a name="l00109"></a>00109 
<a name="l00111"></a><a class="code" href="classOgre_1_1Vector2.html#a307ca54d90a1a35b54a5416810681b3a">00111</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()
<a name="l00112"></a>00112         {
<a name="l00113"></a>00113             <span class="keywordflow">return</span> &amp;x;
<a name="l00114"></a>00114         }
<a name="l00116"></a><a class="code" href="classOgre_1_1Vector2.html#ad72265d712677a9d628f0231c2e7c460">00116</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()<span class="keyword"> const</span>
<a name="l00117"></a>00117 <span class="keyword">        </span>{
<a name="l00118"></a>00118             <span class="keywordflow">return</span> &amp;x;
<a name="l00119"></a>00119         }
<a name="l00120"></a>00120 
<a name="l00125"></a><a class="code" href="classOgre_1_1Vector2.html#a94d813e76f805306436e19a785e75a26">00125</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator = ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00126"></a>00126         {
<a name="l00127"></a>00127             x = rkVector.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00128"></a>00128             y = rkVector.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00129"></a>00129 
<a name="l00130"></a>00130             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00131"></a>00131         }
<a name="l00132"></a>00132 
<a name="l00133"></a><a class="code" href="classOgre_1_1Vector2.html#a057b23bf29fadca9f2a4f0ff19a9bf61">00133</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator = ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar)
<a name="l00134"></a>00134         {
<a name="l00135"></a>00135             x = fScalar;
<a name="l00136"></a>00136             y = fScalar;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00139"></a>00139         }
<a name="l00140"></a>00140 
<a name="l00141"></a><a class="code" href="classOgre_1_1Vector2.html#a4404d6cdc32ecbc7d1b4ff5bc247d68a">00141</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator == </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00142"></a>00142 <span class="keyword">        </span>{
<a name="l00143"></a>00143             <span class="keywordflow">return</span> ( x == rkVector.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a> &amp;&amp; y == rkVector.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a> );
<a name="l00144"></a>00144         }
<a name="l00145"></a>00145 
<a name="l00146"></a><a class="code" href="classOgre_1_1Vector2.html#af8a82d880cf79a247d4eb8a70f61702f">00146</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator != </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00147"></a>00147 <span class="keyword">        </span>{
<a name="l00148"></a>00148             <span class="keywordflow">return</span> ( x != rkVector.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a> || y != rkVector.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>  );
<a name="l00149"></a>00149         }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151         <span class="comment">// arithmetic operations</span>
<a name="l00152"></a><a class="code" href="classOgre_1_1Vector2.html#a806a988c00ef4351b8e6d534bd0f09b6">00152</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> operator + ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00153"></a>00153 <span class="keyword">        </span>{
<a name="l00154"></a>00154             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00155"></a>00155                 x + rkVector.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00156"></a>00156                 y + rkVector.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00157"></a>00157         }
<a name="l00158"></a>00158 
<a name="l00159"></a><a class="code" href="classOgre_1_1Vector2.html#ab00bb30f312804b9eeedb8c8816da88b">00159</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> operator - ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00160"></a>00160 <span class="keyword">        </span>{
<a name="l00161"></a>00161             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00162"></a>00162                 x - rkVector.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00163"></a>00163                 y - rkVector.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00164"></a>00164         }
<a name="l00165"></a>00165 
<a name="l00166"></a><a class="code" href="classOgre_1_1Vector2.html#aae0ed4bc95e76592db876074a7b92c64">00166</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator * </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )<span class="keyword"> const</span>
<a name="l00167"></a>00167 <span class="keyword">        </span>{
<a name="l00168"></a>00168             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00169"></a>00169                 x * fScalar,
<a name="l00170"></a>00170                 y * fScalar);
<a name="l00171"></a>00171         }
<a name="l00172"></a>00172 
<a name="l00173"></a><a class="code" href="classOgre_1_1Vector2.html#a7b3c0ac1956488c8d711c1c684140fb9">00173</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator * </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00174"></a>00174 <span class="keyword">        </span>{
<a name="l00175"></a>00175             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00176"></a>00176                 x * rhs.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00177"></a>00177                 y * rhs.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00178"></a>00178         }
<a name="l00179"></a>00179 
<a name="l00180"></a><a class="code" href="classOgre_1_1Vector2.html#ac22564f2426d1feaf991373d70ee2ba6">00180</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="group__Math.html#ga49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )<span class="keyword"> const</span>
<a name="l00181"></a>00181 <span class="keyword">        </span>{
<a name="l00182"></a>00182             assert( fScalar != 0.0 );
<a name="l00183"></a>00183 
<a name="l00184"></a>00184             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInv = 1.0f / fScalar;
<a name="l00185"></a>00185 
<a name="l00186"></a>00186             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00187"></a>00187                 x * fInv,
<a name="l00188"></a>00188                 y * fInv);
<a name="l00189"></a>00189         }
<a name="l00190"></a>00190 
<a name="l00191"></a><a class="code" href="classOgre_1_1Vector2.html#a0832212595e63003914ab30c2020149b">00191</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="group__Math.html#ga49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00192"></a>00192 <span class="keyword">        </span>{
<a name="l00193"></a>00193             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00194"></a>00194                 x / rhs.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00195"></a>00195                 y / rhs.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00196"></a>00196         }
<a name="l00197"></a>00197 
<a name="l00198"></a><a class="code" href="classOgre_1_1Vector2.html#af22ae1e752951b66f3c3ef59134f1dfc">00198</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator + ()<span class="keyword"> const</span>
<a name="l00199"></a>00199 <span class="keyword">        </span>{
<a name="l00200"></a>00200             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00201"></a>00201         }
<a name="l00202"></a>00202 
<a name="l00203"></a><a class="code" href="classOgre_1_1Vector2.html#aaebb1a9a4be8649241189c6ff02d170c">00203</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> operator - ()<span class="keyword"> const</span>
<a name="l00204"></a>00204 <span class="keyword">        </span>{
<a name="l00205"></a>00205             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(-x, -y);
<a name="l00206"></a>00206         }
<a name="l00207"></a>00207 
<a name="l00208"></a>00208         <span class="comment">// overloaded operators to help Vector2</span>
<a name="l00209"></a><a class="code" href="classOgre_1_1Vector2.html#a87c0a3be9cc3499973c709dba2982127">00209</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator * </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00210"></a>00210         {
<a name="l00211"></a>00211             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00212"></a>00212                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00213"></a>00213                 fScalar * rkVector.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00214"></a>00214         }
<a name="l00215"></a>00215 
<a name="l00216"></a><a class="code" href="classOgre_1_1Vector2.html#a51c18bb1a1071f8078084cb968ddb5d2">00216</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="group__Math.html#ga49268a0dd483041451c010eeec55f83a">operator / </a>( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00217"></a>00217         {
<a name="l00218"></a>00218             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00219"></a>00219                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00220"></a>00220                 fScalar / rkVector.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00221"></a>00221         }
<a name="l00222"></a>00222 
<a name="l00223"></a><a class="code" href="classOgre_1_1Vector2.html#a3ffc15c2ad86866acd071c0748126fbb">00223</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> operator + (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> rhs)
<a name="l00224"></a>00224         {
<a name="l00225"></a>00225             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00226"></a>00226                 lhs.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a> + rhs,
<a name="l00227"></a>00227                 lhs.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a> + rhs);
<a name="l00228"></a>00228         }
<a name="l00229"></a>00229 
<a name="l00230"></a><a class="code" href="classOgre_1_1Vector2.html#a67176f44a1c406e85fe12787373ef377">00230</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> operator + (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lhs, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rhs)
<a name="l00231"></a>00231         {
<a name="l00232"></a>00232             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00233"></a>00233                 lhs + rhs.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00234"></a>00234                 lhs + rhs.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00235"></a>00235         }
<a name="l00236"></a>00236 
<a name="l00237"></a><a class="code" href="classOgre_1_1Vector2.html#aed2661adf58895a08a1b38054d8d5743">00237</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> operator - (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> rhs)
<a name="l00238"></a>00238         {
<a name="l00239"></a>00239             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00240"></a>00240                 lhs.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a> - rhs,
<a name="l00241"></a>00241                 lhs.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a> - rhs);
<a name="l00242"></a>00242         }
<a name="l00243"></a>00243 
<a name="l00244"></a><a class="code" href="classOgre_1_1Vector2.html#a6d976cf52f54a51f4b42ef31c3bede89">00244</a>         <span class="keyword">inline</span> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> operator - (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lhs, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rhs)
<a name="l00245"></a>00245         {
<a name="l00246"></a>00246             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00247"></a>00247                 lhs - rhs.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>,
<a name="l00248"></a>00248                 lhs - rhs.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>);
<a name="l00249"></a>00249         }
<a name="l00250"></a>00250 
<a name="l00251"></a>00251         <span class="comment">// arithmetic updates</span>
<a name="l00252"></a><a class="code" href="classOgre_1_1Vector2.html#aac6485bd52d65876c6d625f0dbbf634b">00252</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator += ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00253"></a>00253         {
<a name="l00254"></a>00254             x += rkVector.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00255"></a>00255             y += rkVector.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00256"></a>00256 
<a name="l00257"></a>00257             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00258"></a>00258         }
<a name="l00259"></a>00259 
<a name="l00260"></a><a class="code" href="classOgre_1_1Vector2.html#a7d85454520d16e1737be3d79b6950d39">00260</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator += ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScaler )
<a name="l00261"></a>00261         {
<a name="l00262"></a>00262             x += fScaler;
<a name="l00263"></a>00263             y += fScaler;
<a name="l00264"></a>00264 
<a name="l00265"></a>00265             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00266"></a>00266         }
<a name="l00267"></a>00267 
<a name="l00268"></a><a class="code" href="classOgre_1_1Vector2.html#aa4e5a79a3880c71499ea5c6fc3709151">00268</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator -= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00269"></a>00269         {
<a name="l00270"></a>00270             x -= rkVector.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00271"></a>00271             y -= rkVector.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00272"></a>00272 
<a name="l00273"></a>00273             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00274"></a>00274         }
<a name="l00275"></a>00275 
<a name="l00276"></a><a class="code" href="classOgre_1_1Vector2.html#adb77e6fdba8c5a6a55b6c53f16a2cf5f">00276</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator -= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScaler )
<a name="l00277"></a>00277         {
<a name="l00278"></a>00278             x -= fScaler;
<a name="l00279"></a>00279             y -= fScaler;
<a name="l00280"></a>00280 
<a name="l00281"></a>00281             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00282"></a>00282         }
<a name="l00283"></a>00283 
<a name="l00284"></a><a class="code" href="classOgre_1_1Vector2.html#aa0e1652d4b655d603334e14174cf176f">00284</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator *= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00285"></a>00285         {
<a name="l00286"></a>00286             x *= fScalar;
<a name="l00287"></a>00287             y *= fScalar;
<a name="l00288"></a>00288 
<a name="l00289"></a>00289             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00290"></a>00290         }
<a name="l00291"></a>00291 
<a name="l00292"></a><a class="code" href="classOgre_1_1Vector2.html#a04fe4323795bdd2edba14979071cc2a8">00292</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator *= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00293"></a>00293         {
<a name="l00294"></a>00294             x *= rkVector.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00295"></a>00295             y *= rkVector.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00296"></a>00296 
<a name="l00297"></a>00297             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00298"></a>00298         }
<a name="l00299"></a>00299 
<a name="l00300"></a><a class="code" href="classOgre_1_1Vector2.html#a5ee66b093d0a415c57e7918523cabeaf">00300</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator /= ( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar )
<a name="l00301"></a>00301         {
<a name="l00302"></a>00302             assert( fScalar != 0.0 );
<a name="l00303"></a>00303 
<a name="l00304"></a>00304             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInv = 1.0f / fScalar;
<a name="l00305"></a>00305 
<a name="l00306"></a>00306             x *= fInv;
<a name="l00307"></a>00307             y *= fInv;
<a name="l00308"></a>00308 
<a name="l00309"></a>00309             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00310"></a>00310         }
<a name="l00311"></a>00311 
<a name="l00312"></a><a class="code" href="classOgre_1_1Vector2.html#a181745a04b7b95bffc331fd9a4519931">00312</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; operator /= ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )
<a name="l00313"></a>00313         {
<a name="l00314"></a>00314             x /= rkVector.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00315"></a>00315             y /= rkVector.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00316"></a>00316 
<a name="l00317"></a>00317             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00318"></a>00318         }
<a name="l00319"></a>00319 
<a name="l00327"></a><a class="code" href="classOgre_1_1Vector2.html#a37afa7257464098c518321ddf438f1a9">00327</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length ()<span class="keyword"> const</span>
<a name="l00328"></a>00328 <span class="keyword">        </span>{
<a name="l00329"></a>00329             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#ab1ee8b71699ce68bd8cf91113ead793e" title="Square root function.">Math::Sqrt</a>( x * x + y * y );
<a name="l00330"></a>00330         }
<a name="l00331"></a>00331 
<a name="l00342"></a><a class="code" href="classOgre_1_1Vector2.html#acf2cf937351e108feb474e01d2c982a2">00342</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> squaredLength ()<span class="keyword"> const</span>
<a name="l00343"></a>00343 <span class="keyword">        </span>{
<a name="l00344"></a>00344             <span class="keywordflow">return</span> x * x + y * y;
<a name="l00345"></a>00345         }
<a name="l00346"></a>00346 
<a name="l00354"></a><a class="code" href="classOgre_1_1Vector2.html#a10530ba97a3d11806123452513890a94">00354</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> distance(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00355"></a>00355 <span class="keyword">        </span>{
<a name="l00356"></a>00356             <span class="keywordflow">return</span> (*<span class="keyword">this</span> - rhs).length();
<a name="l00357"></a>00357         }
<a name="l00358"></a>00358 
<a name="l00369"></a><a class="code" href="classOgre_1_1Vector2.html#a6942a08e1f7fb50c43f87c7186052ac6">00369</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> squaredDistance(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00370"></a>00370 <span class="keyword">        </span>{
<a name="l00371"></a>00371             <span class="keywordflow">return</span> (*<span class="keyword">this</span> - rhs).squaredLength();
<a name="l00372"></a>00372         }
<a name="l00373"></a>00373 
<a name="l00388"></a><a class="code" href="classOgre_1_1Vector2.html#a864971e600fa97e95a295cb5f2c2f16d">00388</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dotProduct(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; vec)<span class="keyword"> const</span>
<a name="l00389"></a>00389 <span class="keyword">        </span>{
<a name="l00390"></a>00390             <span class="keywordflow">return</span> x * vec.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a> + y * vec.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00391"></a>00391         }
<a name="l00392"></a>00392 
<a name="l00403"></a><a class="code" href="classOgre_1_1Vector2.html#a108e27e1f8c56023377347b661cf067c">00403</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> normalise()
<a name="l00404"></a>00404         {
<a name="l00405"></a>00405             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fLength = <a class="code" href="classOgre_1_1Math.html#ab1ee8b71699ce68bd8cf91113ead793e" title="Square root function.">Math::Sqrt</a>( x * x + y * y);
<a name="l00406"></a>00406 
<a name="l00407"></a>00407             <span class="comment">// Will also work for zero-sized vectors, but will change nothing</span>
<a name="l00408"></a>00408             <span class="comment">// We&#39;re not using epsilons because we don&#39;t need to.</span>
<a name="l00409"></a>00409             <span class="comment">// Read http://www.ogre3d.org/forums/viewtopic.php?f=4&amp;t=61259</span>
<a name="l00410"></a>00410             <span class="keywordflow">if</span> ( fLength &gt; <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>(0.0f) )
<a name="l00411"></a>00411             {
<a name="l00412"></a>00412                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fInvLength = 1.0f / fLength;
<a name="l00413"></a>00413                 x *= fInvLength;
<a name="l00414"></a>00414                 y *= fInvLength;
<a name="l00415"></a>00415             }
<a name="l00416"></a>00416 
<a name="l00417"></a>00417             <span class="keywordflow">return</span> fLength;
<a name="l00418"></a>00418         }
<a name="l00419"></a>00419 
<a name="l00423"></a><a class="code" href="classOgre_1_1Vector2.html#ad79868b92edb2c5187d8b11387010a7d">00423</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> midPoint( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; vec )<span class="keyword"> const</span>
<a name="l00424"></a>00424 <span class="keyword">        </span>{
<a name="l00425"></a>00425             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(
<a name="l00426"></a>00426                 ( x + vec.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a> ) * 0.5f,
<a name="l00427"></a>00427                 ( y + vec.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a> ) * 0.5f );
<a name="l00428"></a>00428         }
<a name="l00429"></a>00429 
<a name="l00433"></a><a class="code" href="classOgre_1_1Vector2.html#aa756107b53717cfa38efec9e0840f630">00433</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__General.html#gae1dbf4506ab2500da5ec4ef0b58cb2e1">operator &lt; </a>( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rhs )<span class="keyword"> const</span>
<a name="l00434"></a>00434 <span class="keyword">        </span>{
<a name="l00435"></a>00435             <span class="keywordflow">if</span>( x &lt; rhs.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a> &amp;&amp; y &lt; rhs.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a> )
<a name="l00436"></a>00436                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00437"></a>00437             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00438"></a>00438         }
<a name="l00439"></a>00439 
<a name="l00443"></a><a class="code" href="classOgre_1_1Vector2.html#aa66f1e244af12ef400f1cc416b408e19">00443</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator &gt; ( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rhs )<span class="keyword"> const</span>
<a name="l00444"></a>00444 <span class="keyword">        </span>{
<a name="l00445"></a>00445             <span class="keywordflow">if</span>( x &gt; rhs.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a> &amp;&amp; y &gt; rhs.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a> )
<a name="l00446"></a>00446                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00447"></a>00447             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00448"></a>00448         }
<a name="l00449"></a>00449 
<a name="l00457"></a><a class="code" href="classOgre_1_1Vector2.html#a946495c4a55e1f8048aab6920bf0ac9f">00457</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> makeFloor( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; cmp )
<a name="l00458"></a>00458         {
<a name="l00459"></a>00459             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a> &lt; x ) x = cmp.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00460"></a>00460             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a> &lt; y ) y = cmp.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00461"></a>00461         }
<a name="l00462"></a>00462 
<a name="l00470"></a><a class="code" href="classOgre_1_1Vector2.html#a408be4c5539e93a4272e05249bafe0be">00470</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> makeCeil( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; cmp )
<a name="l00471"></a>00471         {
<a name="l00472"></a>00472             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a> &gt; x ) x = cmp.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00473"></a>00473             <span class="keywordflow">if</span>( cmp.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a> &gt; y ) y = cmp.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a>;
<a name="l00474"></a>00474         }
<a name="l00475"></a>00475 
<a name="l00483"></a><a class="code" href="classOgre_1_1Vector2.html#aea8cb94f0258c7b8f204588f05d7d0f0">00483</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> perpendicular(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00484"></a>00484 <span class="keyword">        </span>{
<a name="l00485"></a>00485             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> (-y, x);
<a name="l00486"></a>00486         }
<a name="l00487"></a>00487 
<a name="l00491"></a><a class="code" href="classOgre_1_1Vector2.html#a9785bfabcea2d2fad738571f5c7c106f">00491</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> crossProduct( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; rkVector )<span class="keyword"> const</span>
<a name="l00492"></a>00492 <span class="keyword">        </span>{
<a name="l00493"></a>00493             <span class="keywordflow">return</span> x * rkVector.<a class="code" href="classOgre_1_1Vector2.html#ad486a13367b71ce0f4c6782297be9725">y</a> - y * rkVector.<a class="code" href="classOgre_1_1Vector2.html#af3eb55ba6d289477e9aa52b8de341380">x</a>;
<a name="l00494"></a>00494         }
<a name="l00495"></a>00495 
<a name="l00515"></a><a class="code" href="classOgre_1_1Vector2.html#abf1030549182b8fcf19def12e2706e6f">00515</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> randomDeviant(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> angle)<span class="keyword"> const</span>
<a name="l00516"></a>00516 <span class="keyword">        </span>{
<a name="l00517"></a>00517 
<a name="l00518"></a>00518             angle *=  <a class="code" href="classOgre_1_1Math.html#a17da3bb870f8654628d6f429a144aea1" title="Generate a random number of unit length.">Math::UnitRandom</a>() * <a class="code" href="classOgre_1_1Math.html#a58d139439316e19e9142000f1a6bdf6d">Math::TWO_PI</a>;
<a name="l00519"></a>00519             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> cosa = cos(angle);
<a name="l00520"></a>00520             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> sina = sin(angle);
<a name="l00521"></a>00521             <span class="keywordflow">return</span>  <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>(cosa * x - sina * y,
<a name="l00522"></a>00522                             sina * x + cosa * y);
<a name="l00523"></a>00523         }
<a name="l00524"></a>00524 
<a name="l00526"></a><a class="code" href="classOgre_1_1Vector2.html#a1946e867aa921f61de967cf244774531">00526</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> isZeroLength(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00527"></a>00527 <span class="keyword">        </span>{
<a name="l00528"></a>00528             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> sqlen = (x * x) + (y * y);
<a name="l00529"></a>00529             <span class="keywordflow">return</span> (sqlen &lt; (1e-06 * 1e-06));
<a name="l00530"></a>00530 
<a name="l00531"></a>00531         }
<a name="l00532"></a>00532 
<a name="l00535"></a><a class="code" href="classOgre_1_1Vector2.html#a735f0406c751af9b3ac79c855301e466">00535</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> normalisedCopy(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00536"></a>00536 <span class="keyword">        </span>{
<a name="l00537"></a>00537             <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> ret = *<span class="keyword">this</span>;
<a name="l00538"></a>00538             ret.<a class="code" href="classOgre_1_1Vector2.html#a108e27e1f8c56023377347b661cf067c" title="Normalises the vector.">normalise</a>();
<a name="l00539"></a>00539             <span class="keywordflow">return</span> ret;
<a name="l00540"></a>00540         }
<a name="l00541"></a>00541 
<a name="l00545"></a><a class="code" href="classOgre_1_1Vector2.html#affe288cd3a7424b7fdb0ae34b2ddf807">00545</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> reflect(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; normal)<span class="keyword"> const</span>
<a name="l00546"></a>00546 <span class="keyword">        </span>{
<a name="l00547"></a>00547             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>( *<span class="keyword">this</span> - ( 2 * this-&gt;dotProduct(normal) * normal ) );
<a name="l00548"></a>00548         }
<a name="l00549"></a>00549 
<a name="l00551"></a><a class="code" href="classOgre_1_1Vector2.html#aea3847aa9c4caa70f2dacd2c145bf18b">00551</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> isNaN()<span class="keyword"> const</span>
<a name="l00552"></a>00552 <span class="keyword">        </span>{
<a name="l00553"></a>00553             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(x) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(y);
<a name="l00554"></a>00554         }
<a name="l00555"></a>00555 
<a name="l00560"></a><a class="code" href="classOgre_1_1Vector2.html#ab1b1d53ca1f653039d906a875d1e3424">00560</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Ogre::Radian</a> angleBetween(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Ogre::Vector2</a>&amp; other)<span class="keyword"> const</span>
<a name="l00561"></a>00561 <span class="keyword">        </span>{       
<a name="l00562"></a>00562             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Ogre::Real</a> lenProduct = length() * other.<a class="code" href="classOgre_1_1Vector2.html#a37afa7257464098c518321ddf438f1a9" title="Returns the length (magnitude) of the vector.">length</a>();
<a name="l00563"></a>00563             <span class="comment">// Divide by zero check</span>
<a name="l00564"></a>00564             <span class="keywordflow">if</span>(lenProduct &lt; 1e-6f)
<a name="l00565"></a>00565                 lenProduct = 1e-6f;
<a name="l00566"></a>00566         
<a name="l00567"></a>00567             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Ogre::Real</a> f = dotProduct(other) / lenProduct;
<a name="l00568"></a>00568     
<a name="l00569"></a>00569             f = <a class="code" href="classOgre_1_1Math.html#a0de224c93b57ff8414892d77f9a2d81d" title="Clamp a value within an inclusive range.">Ogre::Math::Clamp</a>(f, (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Ogre::Real</a>)-1.0, (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Ogre::Real</a>)1.0);
<a name="l00570"></a>00570             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a53869f3197b0f991aea7f5edf6b620e2" title="Arc cosine function.">Ogre::Math::ACos</a>(f);
<a name="l00571"></a>00571         }
<a name="l00572"></a>00572 
<a name="l00578"></a><a class="code" href="classOgre_1_1Vector2.html#acd739f1dbaf36db542a9f04866c5557e">00578</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Ogre::Radian</a> angleTo(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Ogre::Vector2</a>&amp; other)<span class="keyword"> const</span>
<a name="l00579"></a>00579 <span class="keyword">        </span>{
<a name="l00580"></a>00580             <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Ogre::Radian</a> angle = angleBetween(other);
<a name="l00581"></a>00581         
<a name="l00582"></a>00582             <span class="keywordflow">if</span> (crossProduct(other)&lt;0)          
<a name="l00583"></a>00583                 angle = (<a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Ogre::Radian</a>)<a class="code" href="classOgre_1_1Math.html#a58d139439316e19e9142000f1a6bdf6d">Ogre::Math::TWO_PI</a> - angle;       
<a name="l00584"></a>00584 
<a name="l00585"></a>00585             <span class="keywordflow">return</span> angle;
<a name="l00586"></a>00586         }
<a name="l00587"></a>00587 
<a name="l00588"></a>00588         <span class="comment">// special points</span>
<a name="l00589"></a><a class="code" href="classOgre_1_1Vector2.html#a70fef72151781ad0174a004a8b6b3acc">00589</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="classOgre_1_1Vector2.html#a70fef72151781ad0174a004a8b6b3acc">ZERO</a>;
<a name="l00590"></a><a class="code" href="classOgre_1_1Vector2.html#a1c2d210b2756d07375b0cf9f01835496">00590</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="classOgre_1_1Vector2.html#a1c2d210b2756d07375b0cf9f01835496">UNIT_X</a>;
<a name="l00591"></a><a class="code" href="classOgre_1_1Vector2.html#ad20c8c58c9345a71743416bad82cb5e3">00591</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="classOgre_1_1Vector2.html#ad20c8c58c9345a71743416bad82cb5e3">UNIT_Y</a>;
<a name="l00592"></a><a class="code" href="classOgre_1_1Vector2.html#a52e8d29732eacdeb87d20a3372382590">00592</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="classOgre_1_1Vector2.html#a52e8d29732eacdeb87d20a3372382590">NEGATIVE_UNIT_X</a>;
<a name="l00593"></a><a class="code" href="classOgre_1_1Vector2.html#a95486d3e0b884791be22f16d2bb3a4cb">00593</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="classOgre_1_1Vector2.html#a95486d3e0b884791be22f16d2bb3a4cb">NEGATIVE_UNIT_Y</a>;
<a name="l00594"></a><a class="code" href="classOgre_1_1Vector2.html#a165a67053e61b0733746453ce9ee5edb">00594</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="classOgre_1_1Vector2.html#a165a67053e61b0733746453ce9ee5edb">UNIT_SCALE</a>;
<a name="l00595"></a>00595 
<a name="l00598"></a>00598         <span class="keyword">inline</span> <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <span class="keyword">operator</span> &lt;&lt;
<a name="l00599"></a><a class="code" href="classOgre_1_1Vector2.html#af2c1dcbb14e9404733990cdbb2b2d747">00599</a>             ( std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; v )
<a name="l00600"></a>00600         {
<a name="l00601"></a>00601             o &lt;&lt; <span class="stringliteral">&quot;Vector2(&quot;</span> &lt;&lt; v.x &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; v.y &lt;&lt;  <span class="stringliteral">&quot;)&quot;</span>;
<a name="l00602"></a>00602             <span class="keywordflow">return</span> o;
<a name="l00603"></a>00603         }
<a name="l00604"></a>00604     };
<a name="l00608"></a>00608 }
<a name="l00609"></a>00609 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
